#include <stdio.h>
#include <process.h>
#include <sys\timeb.h>
#include <time.h>
#include <dw.h>
#include <dwmenu.h>
#include <miracl.h>

#define COMPLETE 1

#define HANGON while(1){if(gfkbhit()&&getkey()==CR)break;else;}

HWND baudwin,errwin,ofwin,mywin,yourwin,win,twin,rwin,statwin,logwin,callwin;
HWND cted;
MENUHDR *mnu,*mainmnu;
MENUITEM *mfile,*shell,*quit,*temp,*mlog;

static FILE *fp;
static char licensee[100];
static char roottext[200];
static char compotext[200];
static char herlicense[100];
static char work[200];
static int proot;
static MENUITEM *b[5],*d[2],*p[2],*m[4];
static HWND dialwin,waitwin,modemwin;
static big root,compo,mypublic,myprivate,herpublic,key,licensenum,ranno;
static long baud_rates[5]={300,1200,2400,4800,9600};
static unsigned int mode,dialmode,port,baud;
static char number[30];
static char *fixed={"AUTHORISED PC-SCRAMBLER USER -> "};
static char validchars[]= " 0123456789/,@wWrRpPtT()-;\b";

static char *advert[]={
"\n",
" Welcome to PC-SCRAMBLER, which is bad news for Phone Tappers,  as it allows\n",
" you to converse and swap files with distant associates in complete privacy,\n", 
" using State-of-the-Art ideas from Modern Cryptography.  No need to remember\n",
" a Password  -  the keys are generated automatically.  The  identity of your\n", 
" partner is even verified by PC-SCRAMBLER.\n",
"\n",
" Setting up a secure link involves some  rather  difficult  and  potentially\n",
" time-consuming calculations.  The faster your PC, the shorter these delays.\n",
"\n",
" This product is  SHAREWARE,  and is dedicated to that fine body of (mostly)\n", 
" men, the Irish Special Branch and their equivalents the world over   -  who\n", 
" habitually tap the telephones of journalists and political activists.\n",
"\n",
" This copy of PC-SCRAMBLER is licensed to:-\n",
"\n ",
work,
"\n",
"                        Press RETURN to continue\n",
"\n",
"\n",
"       (C) Copyright Shamus Software Ltd 1988-1991, Dublin, Ireland"};


static bool proceed()
{
   int ch;
   forever
   {
       if (gfkbhit())
       {
           ch=getkey();
           if (ch==CR) return TRUE;
           if (ch==ESC) return FALSE;
       }
   }
}

void onewayhash(string,n,x)
char *string;
big n,x;
{ /* nonlinear (portable) permutation *
   * x=(fixed|string xor R(n))^2 mod n      */
    int i,k,len;
    strcpy(work,fixed);
    strcat(work,string);
    INPLEN=otnum(n,NULL);
    for (i=0,k=INPLEN-1;i<INPLEN;i++,k--) IBUFF[i]=OBUFF[k];
    len=strlen(work);
    for (i=0;i<len;i++) IBUFF[i]^=work[i];
    innum(x,NULL);
    mad(x,x,x,n,n,x);
}

bool verify()
{ /* verify .kst file format and users ID */
    if (strlen(compotext)<80 || strlen(roottext)<80 || proot<2) return FALSE;
    strcpy(IBUFF,roottext);
    cinnum(root,NULL);
    strcpy(IBUFF,compotext);
    cinnum(compo,NULL);
    power(root,3,compo,key);
    onewayhash(licensee,compo,licensenum);
    xgcd(root,compo,root,root,root);  /* root = 1/root */
    if (compare(key,licensenum)!=0) return FALSE;
    return TRUE;
}

int raninc(tbuff)
struct timeb tbuff;
{  /* return random number based on time */
    return (tbuff.millitm/10+((int)(tbuff.time%300)*100));
}

static void newkey()
{
    int nd,ch;
    struct timeb tbuff3;

    ftime(&tbuff3);
    mad(ranno,ranno,ranno,compo,compo,ranno);
    incr(ranno,raninc(tbuff3),ranno);
    copy(ranno,myprivate);
    expb2(80,mypublic);
    divide(myprivate,mypublic,mypublic);
    visible(waitwin,YES,NO);
    vdispstr(waitwin,"Calculating public encryption key......");

/*  mypublic = root*proot^myprivate mod compo */

    powltr(proot,myprivate,compo,mypublic);
    mad(mypublic,root,root,compo,compo,mypublic);
    visible(waitwin,NO,NO);
    vclear(waitwin);
}

static int connect(p)
MENUITEM *p;
{
    int i,ch,cnt,k,olen,ilen,t;
    bool valid;
    newkey();
    if (mode==1)
    { /* get dial string */
        vdispstr(dialwin,"Phone Number: ");
        vdispstr(dialwin,number);
        curdrag(dialwin,ON);
        visible(dialwin,YES,YES);

        cnt=strlen(number);                  
        while ((ch=getkey())!=CR && ch!=ESC)
        { /* get phone number */
            if (ch==0)
            { /* ignore extended codes */
                getkey();
                continue;
            }
            for (i=0;;i++)
            { /* check for valid characters */
                valid=TRUE;
                t=validchars[i];
                if (ch==t) break;
                valid=FALSE;
                if (t==0) break;
            }
            if (!valid) continue;
            if (ch=='\b')
            { /* backspace */
                if (cnt==0) continue;
                cnt--;
            }
            else 
            {
                if (cnt>25) continue;
                number[cnt++]=ch;
            }
            vdispch(dialwin,ch);
        }   
        number[cnt]=0;
        visible(dialwin,NO,NO);
        vclear(dialwin);
        if (ch==ESC || cnt==0) return 0;
    }
    forever
    {  /* Make Modem Connection */
        start_link(port,baud_rates[baud],mode);
        if (mode==1) dial(number,dialmode);
        vdispstr(waitwin,"Waiting for a modem connection......");
        if (mode==0 || mode==2) do
        { /* make good modem connection */
            visible(modemwin,YES,NO);
            if (!proceed()) 
            { /* abort it */
                vclear(waitwin);
                visible(waitwin,NO,NO);
                visible(modemwin,NO,NO);
                end_link();
                return 0;
            }
            visible(modemwin,NO,NO);
            visible(waitwin,YES,NO);
        } while (!modem_link());
        if (mode==1 || mode==3)
        { 
            visible(waitwin,YES,NO);
            if (!modem_link())
            {
                vclear(waitwin);
                visible(waitwin,NO,NO);
                end_link();
                return 0;
            }
        }
        vclear(waitwin);
        vbeep();

/* Okamoto's exponential key exchange */

        vdispstr(waitwin,"Communicating public encryption key......");
        olen=otnum(mypublic,NULL);
        if (exchange_strings(5,olen,OBUFF,&ilen,IBUFF)!=COMPLETE)  
        {  /* there is a problem... */
            vclear(waitwin);
            vdispstr(waitwin,"Sorry - there is a communications problem");
            end_link();
            visible(waitwin,NO,NO);
            vclear(waitwin);
            if (mode!=3) return 0;
            else continue;
        }
        INPLEN=ilen;
        innum(herpublic,NULL);
        vclear(waitwin);

        vdispstr(waitwin,"Calculating private encryption key......");

/*  key = (herpublic^3*herID)^myprivate mod compo */

        power(herpublic,3,compo,herpublic);
        exchange_strings(0,strlen(licensee)+1,licensee,&ilen,herlicense);

        onewayhash(herlicense,compo,licensenum);
        mad(herpublic,licensenum,licensenum,compo,compo,herpublic);
        powmod(herpublic,myprivate,compo,key);

        setpad(compo,key,mode);    /* use key to initialise one-time pad */
        herlicense[ilen-2]='\0';   /* remove CR */
        zero(key);
        zero(licensenum);

        exchange_strings(0,strlen(fixed)+1,fixed,&ilen,work);
        if (strcmp(fixed,work)!=0)
        { /* key exchange has failed - keys are different */
            vclear(waitwin);
            vdispstr(waitwin,"Sorry - Key negotiation has failed");     
            end_pad();
            end_link();
            visible(waitwin,NO,NO);
            vclear(waitwin);
            if(mode!=3) return 0;
            newkey();
            continue;
        }

        visible(waitwin,NO,NO);
        vclear(waitwin);

        exchange_chat(0,herlicense,mode);

        end_pad();
        end_link();
        if (mode!=3) break;
        newkey();
    }
    return 0;
}

static int smode(p)
MENUITEM *p;
{ /* mode select function */
    int i;
    MNUUnCheckLevel(p);
    MNUToggleCheck(p);
    for (i=0;i<4;i++) if (p==m[i]) mode=i;
    return 0;
}

static int sbaud(p)
MENUITEM *p;
{ /* baud select function */
    int i;
    MNUUnCheckLevel(p);
    MNUToggleCheck(p);
    for (i=0;i<5;i++) if (p==b[i]) baud=i;
    return 0;
}

static int sport(m)
MENUITEM *m;
{ /* port select function */
    int i;
    MNUUnCheckLevel(m);
    MNUToggleCheck(m);
    for (i=0;i<2;i++) if (m==p[i]) port=i;
    return 0;
}

static int sdial(p)
MENUITEM *p;
{ /* dial mode select function */
    int i;
    MNUUnCheckLevel(p);
    MNUToggleCheck(p);
    for (i=0;i<2;i++) if (p==d[i]) dialmode=i;
    return 0;
}

void main(argc,argv)
int argc;
char **argv;
{
    MENUITEM *orig, *ans, *mbaud, *tfile, *temp=0;
    MENUITEM *mconnect,*mainquit,*mport,*mdial;
    char kstname[20];
    int i,ch;
    long lr;
    unsigned short *bucket;
    int cursorpos;
    struct timeb tbuff1,tbuff2;


    mirsys(200,256); 
    root=mirvar(0);
    compo=mirvar(0);
    mypublic=mirvar(0);
    herpublic=mirvar(0);
    myprivate=mirvar(0);
    licensenum=mirvar(0);
    key=mirvar(0);
    ranno=mirvar(0);
    IOBASE=60;
    WRAP=OFF;

    argv++;
    argc--;
    if (argc==1) strcpy(kstname,argv[0]);
    else         strcpy(kstname,"scramble");
    strcat(kstname,".kst");
    ch=0;
    if ((fp=fopen(kstname,"r"))!=NULL)
    { /* read in key data */
        fgets(licensee,100,fp);
        ch=fscanf(fp,"%s%s%d",roottext,compotext,&proot);
        fclose(fp);
    }
    if (ch!=3 || !verify())
    { /*  invalid file */
        printf("Invalid .kst file format - or file does not exist\n"); 
        exit(0);
    }

    bucket=(unsigned short *)calloc((prows()*pcols()*2),1);
    SaveScreen(&bucket,&cursorpos);

    tocolor();
    if (iscolor()) setdwlib(1,3,25,NO);
    else           setdwlib(0,7,25,NO);

    pclrattr(REVEMPHNORML);
    if (mousinst()) ctlmscur(OFF);
    win=vcreat(23,80,NORML,NO);
    vautofrm(win,NORML,FRDOUBLE);
    vlocate(win,1,1);
    vtitle(win,NORML,"PC-Scrambler V5.0");

    ftime(&tbuff1);
    for (i=0;i<22;i++) vdispstr(win,advert[i]);
    visible(win,YES,NO);
    HANGON;

    waitwin=vcreat(1,64,ERR,NO);
    vautofrm(waitwin,ERR,FRSINGLE);
    vlocate(waitwin,8,3);
    vtitle(waitwin,ERR,"Please wait");
    dialwin=vcreat(1,45,HIGHERR,NO);
    vautofrm(dialwin,HIGHERR,FRSINGLE);
    vtitle(dialwin,HIGHERR,"Edit Dial String and Press RETURN");
    vlocate(dialwin,8,9);
    modemwin=vcreat(1,64,MARK,NO);
    vautofrm(modemwin,MARK,FRSINGLE);
    vlocate(modemwin,8,3);
    vtitle(modemwin,MARK,"Make Modem Connection");
    vdispstr(modemwin,"Connect modems - Press RETURN when ready - then replace handset");

    mainmnu=MNUCreateHdr(POPUP);
    MNUSetCheckMark(mainmnu,3,CURRENT);
    MNUSetDisplayPosition(mainmnu,1,40);
    MNUSetPopUpDisplacement(mainmnu,CURRENT,CURRENT);
    MNUSetSpaces(mainmnu,2);

    mconnect=MNUAddItem("Connect",NULL,'C',0,NULL,mainmnu,connect);
    MNUSetRepaint(mconnect,NO);
    MNUSetReturn(mconnect,OFF,NO);
    m[0]= MNUAddItem("Originate - Manual",NULL,'O',0,NULL,mainmnu,smode);
    m[1]= MNUAddItem("Originate - Autodial",NULL,'d',0,NULL,mainmnu,smode);
    m[2]= MNUAddItem("Answer    - Manual",NULL,'A',0,NULL,mainmnu,smode);
    m[3]= MNUAddItem("Answer    - Autoanswer",NULL,'a',0,NULL,mainmnu,smode);
    for (i=0;i<4;i++) MNUSetReturn(m[i],OFF,NO);
    MNUSetSeparatorBefore(m[0]);

    mbaud= MNUAddItem("Baud-rate",NULL,'B',0,NULL,mainmnu,NULLF);
    MNUSetSeparatorBefore(mbaud);
    b[0]= MNUAddItem("300",NULL,'3',0,mbaud,mainmnu,sbaud);
    b[1]= MNUAddItem("1200",NULL,'1',0,mbaud,mainmnu,sbaud);
    b[2]= MNUAddItem("2400",NULL,'2',0,mbaud,mainmnu,sbaud);
    b[3]= MNUAddItem("4800",NULL,'4',0,mbaud,mainmnu,sbaud);
    b[4]= MNUAddItem("9600",NULL,'9',0,mbaud,mainmnu,sbaud);
    for (i=0;i<5;i++) MNUSetReturn(b[i],OFF,NO);

    mdial=MNUAddItem("Dial Mode",NULL,'M',0,NULL,mainmnu,NULLF);
    d[0]= MNUAddItem("Pulse",NULL,'P',0,mdial,mainmnu,sdial);
    d[1]= MNUAddItem("Tone",NULL,'T',0,mdial,mainmnu,sdial);
    for (i=0;i<2;i++) MNUSetReturn(d[i],OFF,NO);

    mport= MNUAddItem("Comms Port",NULL,'P',0,NULL,mainmnu,NULLF);
    p[0]= MNUAddItem("COM 1",NULL,'1',0,mport,mainmnu,sport);
    p[1]= MNUAddItem("COM 2",NULL,'2',0,mport,mainmnu,sport);
    for (i=0;i<2;i++) MNUSetReturn(p[i],OFF,NO);

    mainquit= MNUAddItem("Quit Scrambler",NULL,'Q',0,NULL,mainmnu,NULLF);
    MNUSetSeparatorBefore(mainquit);

    mnu=MNUCreateHdr(POPUP);
    MNUSetDisplayPosition(mnu,4,4);
    quit= MNUAddItem("Quit Communication",NULL,'Q',0,NULL,mnu,NULLF);
    mfile=MNUAddItem("Start File Transmision",NULL,'S',0,NULL,mnu,NULLF);
    shell=MNUAddItem("DOS Shell",NULL,'D',0,NULL,mnu,NULLF);
    mlog=MNUAddItem("Log On",NULL,'L',0,NULL,mnu,NULLF);

    yourwin=vcreat(12,38,EMPHNORML,YES);
    vautofrm(yourwin,REVNORML,FRDOUBLE);
    vtitle(yourwin,REVNORML,"You");
    vlocate(yourwin,2,1);

    mywin=vcreat(8,38,REVEMPHNORML,YES);
    vautofrm(mywin,REVNORML,FRDOUBLE);
    vtitle(mywin,REVNORML,"Me");
    vlocate(mywin,16,1);
    vclrattr(mywin,EMPHNORML);
    leeow(mywin);


    ofwin=vcreat(1,41,HIGHERR,NO);
    vautofrm(ofwin,HIGHERR,FRSINGLE);
    vtitle(ofwin,HIGHERR,"File Transmission");
    vlocate(ofwin,5,2);

    baudwin=vcreat(1,5,REVNORML,NO);
    vlocate(baudwin,9,65);

    errwin=vcreat(1,30,ERR,NO);
    vautofrm(errwin,ERR,FRSINGLE);
    vtitle(errwin,ERR,"Press ESC to continue");
    vlocate(errwin,6,5);

    twin=vcreat(1,35,MARK,NO);
    vlocate(twin,0,0);
    vdispstr(twin,"Transmitting file                0%");

    rwin=vcreat(1,33,HIGHERR,NO);
    vlocate(rwin,0,35);
    vdispstr(rwin,"Receiving file                0%");

    statwin=vcreat(8,29,REVNORML,NO);
    vautofrm(statwin,REVNORML,FRSINGLE);
    vtitle(statwin,REVNORML,"Link Statistics");
    vlocate(statwin,16,41);
    vdispstr(statwin,"Data Frames sent\n");
    vdispstr(statwin,"Data Frames Received\n");
    vdispstr(statwin,"Naks Sent\n");
    vdispstr(statwin,"Naks Received\n");
    vdispstr(statwin,"Acks Sent\n");
    vdispstr(statwin,"Acks Received\n");
    vdispstr(statwin,"Control Frames Sent\n");
    vdispstr(statwin,"Time-Outs");

    logwin=vcreat(1,3,REVNORML,NO);
    vlocate(logwin,0,68);
    vdispstr(logwin,"Log");

    callwin=vcreat(1,36,NORML,NO);
    vautofrm(callwin,NORML,FRSINGLE);
    vtitle(callwin,NORML,"Your Authenticated Identity:");
    vlocate(callwin,3,2);

    cted=vcreat(1,22,REVNORML,NO);
    vlocate(cted,2,44);
    vdispstr(cted,"\nConnected");

    ftime(&tbuff2);

    if ((fp=fopen("scramble.ini","r"))!=NULL)
    { /* get previous status */
        baud=fgetc(fp)-48;
        port=fgetc(fp)-48;
        mode=fgetc(fp)-48;
        dialmode=fgetc(fp)-48;
        fgetc(fp); /* get CR */
        i=0;
        while ((ch=fgetc(fp))!=EOF && ch!=0) number[i++]=ch;
        number[i]=0;
        fgetc(fp); /* get CR */
        cinnum(ranno,fp);
        fclose(fp);
    }
    else 
    {
        baud=2;
        port=0;
        mode=0;
        dialmode=0;
        number[0]=0;
        irand(tbuff1.time);
        bigrand(compo,ranno);
    }
    incr(ranno,raninc(tbuff1),ranno);
    mad(ranno,ranno,ranno,compo,compo,ranno);
    incr(ranno,raninc(tbuff2),ranno);

    if (port<2) MNUToggleCheck(p[port]);
    if (mode<4) MNUToggleCheck(m[mode]);
    if (dialmode<2) MNUToggleCheck(d[dialmode]);
    if (baud>4) baud=2;
    if (mode>3) mode=3;
    MNUToggleCheck(b[baud]);

    start_comms(baud_rates[baud]);

    vdelete(win,NONE);  

    visible(yourwin,YES,NO);
    visible(mywin,YES,NO);
    visible(statwin,YES,NO);
    visible(callwin,YES,NO);

    do {
        temp=MNUDoSelect(mainmnu,NULLF);
    } while (temp!=mainquit);

    vclean();
    vdelete(logwin,NONE);
    vdelete(statwin,NONE);
    vdelete(ofwin,NONE);
    vdelete(twin,NONE);
    vdelete(rwin,NONE);
    vdelete(callwin,NONE);
    vdelete(mywin,NONE);
    vdelete(yourwin,NONE);
    vdelete(errwin,NONE);
    vdelete(baudwin,NONE);
    vdelete(cted,NONE);

    zero(myprivate);
    end_comms();

  /* update status file */
    fp=fopen("scramble.ini","w");
    fputc(48+baud,fp);
    fputc(48+port,fp);
    fputc(48+mode,fp);
    fputc(48+dialmode,fp);
    fputc(LF,fp);
    i=0;
    do 
    { /* put out phone number */
       ch=number[i++];
       fputc(ch,fp);
    } while (ch!=0);
    fputc(LF,fp);
    cotnum(ranno,fp);
    fclose(fp);
    RestoreScreen(&bucket,&cursorpos);
    pcuron();
}

